---
title: EXT_disjoint_timer_query
slug: Web/API/EXT_disjoint_timer_query
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong>EXT_disjoint_timer_query</strong> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and provides a way to measure the duration of a set of GL commands, without stalling the rendering pipeline.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension should be available in {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} contexts only. {{domxref("EXT_disjoint_timer_query_webgl2")}} is available in {{domxref("WebGL2RenderingContext", "WebGL 2", "", 1)}} contexts .</p>

<p>In WebGL 2, the {{domxref("getQueryObject")}} was renamed to {{domxref("getQueryParameter")}}.<br>
 In WebGL 2, other queries (such as occlusion queries and primitive queries) are possible using {{domxref("WebGLQuery")}} objects.</p>
</div>

<h2 id="Types">Types</h2>

<p>This extension exposes a new type:</p>

<dl>
 <dt>GLuint64EXT</dt>
 <dd>Unsigned 64-bit integer number.</dd>
</dl>

<h2 id="Constants">Constants</h2>

<p>This extension exposes seven new constants.</p>

<dl>
 <dt><code>ext.QUERY_COUNTER_BITS_EXT</code></dt>
 <dd>A {{domxref("GLint")}} indicating the number of bits used to hold the query result for the given target.</dd>
 <dt><code>ext.CURRENT_QUERY_EXT</code></dt>
 <dd>A {{domxref("WebGLQuery")}} object, which is the currently active query for the given target.</dd>
 <dt><code>ext.QUERY_RESULT_EXT</code></dt>
 <dd>A {{domxref("GLuint64EXT")}} containing the query result.</dd>
 <dt><code>ext.QUERY_RESULT_AVAILABLE_EXT</code></dt>
 <dd>A {{domxref("GLboolean")}} indicating whether or not a query result is available.</dd>
 <dt><code>ext.TIME_ELAPSED_EXT</code></dt>
 <dd>Elapsed time (in nanoseconds).</dd>
 <dt><code>ext.TIMESTAMP_EXT</code></dt>
 <dd>The current time.</dd>
 <dt><code>ext.GPU_DISJOINT_EXT</code></dt>
 <dd>A {{domxref("GLboolean")}} indicating whether or not the GPU performed any disjoint operation.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>This extension exposes eight new methods.</p>

<dl>
 <dt>{{domxref("EXT_disjoint_timer_query.createQueryEXT()", "ext.createQueryEXT()")}}</dt>
 <dd>
 <p>Creates a new {{domxref("WebGLTimerQueryEXT")}}.</p>
 </dd>
 <dt>{{domxref("EXT_disjoint_timer_query.deleteQueryEXT()", "ext.deleteQueryEXT()")}}</dt>
 <dd>
 <p>Deletes a given {{domxref("WebGLTimerQueryEXT")}}.</p>
 </dd>
 <dt>{{domxref("EXT_disjoint_timer_query.isQueryEXT()", "ext.isQueryEXT()")}}</dt>
 <dd>
 <p>Returns <code>true</code> if a given object is a valid {{domxref("WebGLTimerQueryEXT")}}.</p>
 </dd>
 <dt>{{domxref("EXT_disjoint_timer_query.beginQueryEXT()", "ext.beginQueryEXT()")}}</dt>
 <dd>The timer starts when all commands prior to <code>beginQueryEXT</code> have been fully executed.</dd>
 <dt>{{domxref("EXT_disjoint_timer_query.endQueryEXT()", "ext.endQueryEXT()")}}</dt>
 <dd>The timer stops when all commands prior to <code>endQueryEXT</code> have been fully executed.</dd>
 <dt>{{domxref("EXT_disjoint_timer_query.queryCounterEXT()", "ext.queryCounterEXT()")}}</dt>
 <dd>
 <p>Records the current time into the corresponding query object.</p>
 </dd>
 <dt>{{domxref("EXT_disjoint_timer_query.getQueryEXT()", "ext.getQueryEXT()")}}</dt>
 <dd>Returns information about a query target.</dd>
 <dt>{{domxref("EXT_disjoint_timer_query.getQueryObjectEXT()", "ext.getQueryObjectEXT()")}}</dt>
 <dd>Return the state of a query object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">var ext = gl.getExtension('EXT_disjoint_timer_query');
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('EXT_disjoint_timer_query', '', 'EXT_disjoint_timer_query')}}</td>
   <td>{{Spec2('EXT_disjoint_timer_query')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.EXT_disjoint_timer_query")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
</ul>
